import java.applet.Applet;
import java.awt.*;
/**
 * Applet which simulates the Z3 (1941 Konrad Zuse) decimal place
 * adjuster.
 * @author Cneyt Gktekin
 * @version 1.0
 */
public class DecPlaceAdjuster extends Applet implements Runnable {
  // needed for -double buffering-
  Dimension offDimension;
  Image offImage;
  Graphics offGraphics;
  /** Some booleans to control the circuit. */
  /** ON/OFF button. */
  boolean on=false;
  /** Reset button. */
  boolean c=false;
  // Image handling
  /** Images for the control buttons.*/
  Image onAI;
  Image onDI;
  Image offI;
  Image resetONI;
  Image resetOFFI;
  Image buttonOnI;
  Image buttonOffI;
  /** Image for on/off bit key. */
  Image[] bitOnI;
  Image[] bitOffI;
  // Circuit Images. */
  /** Switches. */
  Image switchOffI;
  Image switchOnI;
  /** Main switch line on the top. */
  Image swLineI;
  /** Left vertical line of the circuit (active/inactive). */
  Image leftVertLineOnI;
  Image leftVertLineOffI;
  Image leftVertLineSemiI;
  /** Right vertical line of the circuit (active/inactive). */
  Image rightVertLineOnI;
  Image rightVertLineOffI;
  Image rightVertLineSemiI;
  /** Relays. */
  Image relayOnI;
  Image relayOffI;
  Image rRelayOnI;
  Image rRelayOffI;
  /** Rotating arrow images. */
  Image[] arrowI;
  Image[] arrowOnI;
  /** Exponent buttons. */
  public boolean[] buttons=new boolean[17];
  /** Indicator if the Exponent is positive/negative or zero. */
  boolean positive;
  boolean negative;
  boolean zero;
  /** Media tracker to keep loading under control. */
  MediaTracker tracker;
  /** The main simulation thread. */
  private Thread thread=null;
  /** Counter to rotate the arrow. */
  private int arrowNr=0;
  /** 
   * Method realizes the reset button (C).
   * It creates a new array with false values.
   */
  private void c() {
    buttons=new boolean[17];
    negative=false;
    zero=false;
    positive=false;
  }
  /**
   * Loading Images and some other initialization.
   */
  public void init() {
    // Initializing decs
    c();
    // Loading images
    // first create a new MediaTracker object
    tracker=new MediaTracker(this);
    // control images
    onAI=getImage(getCodeBase(),"Images/Buttons/onA.gif");
    tracker.addImage(onAI,0);
    onDI=getImage(getCodeBase(),"Images/Buttons/onD.gif");
    tracker.addImage(onDI,0);
    offI=getImage(getCodeBase(),"Images/Buttons/off.gif");
    tracker.addImage(offI,0);
    resetOFFI=getImage(getCodeBase(),"Images/Buttons/resetOff.gif");
    tracker.addImage(resetOFFI,0);
    resetONI=getImage(getCodeBase(),"Images/Buttons/resetOn.gif");
    tracker.addImage(resetONI,0);
    buttonOnI=getImage(getCodeBase(),"Images/Buttons/buttonOn.gif");
    tracker.addImage(buttonOnI,21);
    buttonOffI=getImage(getCodeBase(),"Images/Buttons/buttonOff.gif");
    tracker.addImage(buttonOffI,22);
    // Images needed for all levels
    // switch Line
    swLineI=getImage(getCodeBase(),"Images/swLine.gif");
    tracker.addImage(swLineI,1);
    // switch on/off
    switchOnI=getImage(getCodeBase(),"Images/switchOn.gif");
    tracker.addImage(switchOnI,2);
    switchOffI=getImage(getCodeBase(),"Images/switchOff.gif");
    tracker.addImage(switchOffI,3);
    // left vertical line (active/inactive)
    leftVertLineOnI=getImage(getCodeBase(),"Images/leftVertLineOn.gif");
    tracker.addImage(leftVertLineOnI,4);
    leftVertLineOffI=getImage(getCodeBase(),"Images/leftVertLineOff.gif");
    tracker.addImage(leftVertLineOffI,5);
    leftVertLineSemiI=getImage(getCodeBase(),"Images/leftVertLineSemi.gif");
    tracker.addImage(leftVertLineSemiI,24);
    // right vertical line (active/inactive)
    rightVertLineOnI=getImage(getCodeBase(),"Images/rightVertLineOn.gif");
    tracker.addImage(rightVertLineOnI,6);
    rightVertLineOffI=getImage(getCodeBase(),"Images/rightVertLineOff.gif");
    tracker.addImage(rightVertLineOffI,7);
    rightVertLineSemiI=getImage(getCodeBase(),"Images/rightVertLineSemi.gif");
    tracker.addImage(rightVertLineSemiI,23);
    // Loading relays
    relayOnI=getImage(getCodeBase(),"Images/relayOn.gif");
    tracker.addImage(relayOnI,8);
    relayOffI=getImage(getCodeBase(),"Images/relayOff.gif");
    tracker.addImage(relayOffI,9);
    rRelayOnI=getImage(getCodeBase(),"Images/rRelayOn.gif");
    tracker.addImage(rRelayOnI,10);
    rRelayOffI=getImage(getCodeBase(),"Images/rRelayOff.gif");
    tracker.addImage(rRelayOffI,11);
    // Loading arrows
    arrowI=new Image[9];
    for(int i=0;i<9;i++) {
      arrowI[i]=getImage(getCodeBase(),"Images/arrow"+i+".gif");
      tracker.addImage(arrowI[i],i+12);
    }
    arrowOnI=new Image[9];
    for(int i=0;i<9;i++) {
      arrowOnI[i]=getImage(getCodeBase(),"Images/arrowOn"+i+".gif");
      tracker.addImage(arrowOnI[i],i+24);
    }
  }
  public void start() {
    if (thread==null) {
      thread=new Thread(this);
      thread.start();
    }
    else {
      thread=null;
      thread=new Thread(this);
      thread.start();
    }
  }
  public void stop() {
    thread=null;
  }
  /** 
   * Standard mouse event Method.
   * In this Method the clickable areas are defined.
   * @param e MouseEvent
   * @param x x coordinate 
   * @param y y coordinate
   */
  public boolean mouseDown(Event e,int x,int y) {
    // Managing behaviour on OFF button
    int x1Local=20;
    int y1Local=10;
    if((x>x1Local)&&(x<(x1Local+30))&&(y<y1Local+30)&&(y>y1Local)) {
      c();start();on=false;start();
    }
    // Managing behaviour on ON button
    x1Local+=30;
    if((x>x1Local)&&(x<(x1Local+30))&&(y<y1Local+30)&&(y>y1Local)) {
      on=true;start();
    }
    // Managing behaviour on reset button
    x1Local+=50;
    if((x>x1Local)&&(x<(x1Local+40))&&(y<y1Local+40)&&(y>y1Local)) {
      c=(c ? false:true);start();
    }
    // Managing behaviour on exponent buttons
    x1Local=155;
    int x2Local=25;
    for(int i=0; i<17;i++) {
      if((x>x1Local)&&(x<(x1Local+25))&&(y<y1Local+25)&&(y>y1Local)) {
        buttons=new boolean[17];
        buttons[i]=(buttons[i] ? false:true);
      }
      x1Local+=25;
    }
    start();
    return true;
  }
  /** Method that puts the control buttons on the sheet. */
  private void putControlsC() {
    // putting ON/OFF button on sheet
    int distX=20;
    int distY=10;
    if(on) {
      offGraphics.drawImage(offI,distX,distY,this);
      offGraphics.drawImage(onAI,distX+30,distY,this);
    }
    else {
      offGraphics.drawImage(offI,distX,distY,this);
      offGraphics.drawImage(onDI,distX+30,distY,this);
    }
    // putting reset button on sheet
    distX+=80;
    offGraphics.drawImage(resetOFFI,distX,distY,this);
    if(c) {
      offGraphics.drawImage(resetOFFI,distX,distY,this);
      c();start();
      offGraphics.drawImage(resetONI,distX,distY,this);
      c=false;start();
      on=false;start();
    }
    // putting buttons for exponent adjustment
    int tx=55;
    int j=8;
    for(int i=0;i<8;i++) {
      if(buttons[i]) {
        negative=true;positive=false;zero=false;
        offGraphics.drawImage(buttonOnI,distX+tx,distY,this);
      }
      else offGraphics.drawImage(buttonOffI,distX+tx,distY,this);
      offGraphics.drawString("-"+j,distX+tx+2,distY+14);
      tx+=25;j--;
    }
    if(buttons[8]) {
      negative=false;positive=false;zero=true;
      offGraphics.drawImage(buttonOnI,distX+tx,distY,this);
    }
    else offGraphics.drawImage(buttonOffI,distX+tx,distY,this);
    offGraphics.drawString("0",distX+tx+7,distY+14);
    tx+=25;
    j=1;
    for(int i=9;i<17;i++) {
      if(buttons[i]) {
        negative=false;positive=true;zero=false;
        offGraphics.drawImage(buttonOnI,distX+tx,distY,this);
      }
      else offGraphics.drawImage(buttonOffI,distX+tx,distY,this);
      offGraphics.drawString("+"+j,distX+tx+2,distY+14);
      tx+=25;j++;
    }
  }
  /** Method that puts the main circuit components on the sheet. */
  public void putC() {
    // putting switch line on sheet
    int distX=150;
    int distY=40;
    offGraphics.drawImage(swLineI,distX,distY,this);
    // putting switches on line
    distX=200;
    distY=44;
    int sum=20;
    for(int i=0; i<17; i++) {
      // switch
      if(buttons[i]&&on) offGraphics.drawImage(switchOnI,distX,distY,this);
      else offGraphics.drawImage(switchOffI,distX,distY,this);
      distX+=sum;
    }
    // putting left vertical lines on sheet
    distX=200;
    distY=44;
    for(int i=0; i<8; i++) {
      if(negative&&on) {
        if(buttons[i]) 
          offGraphics.drawImage(leftVertLineOnI,distX+2,distY+38,this);
        else 
          offGraphics.drawImage(leftVertLineSemiI,distX+2,distY+38,this);
      }
      else offGraphics.drawImage(leftVertLineOffI,distX+2,distY+38,this);
        
      distX+=sum;
    }
    //putting right vertical lines on sheet
    distX=375;
    distY=44;
    for(int i=0; i<8; i++) {
      if(positive&&on) {
        if(buttons[i+9]) 
          offGraphics.drawImage(rightVertLineOnI,distX+2,distY+38,this);
        else 
          offGraphics.drawImage(rightVertLineSemiI,distX+2,distY+38,this);
      }
      else offGraphics.drawImage(rightVertLineOffI,distX+2,distY+38,this);
      distX+=sum;
    }
    // drawing line for switch 0
    distX=365;
    distY=82;
    if(zero&&on) offGraphics.setColor(Color.red);
    else offGraphics.setColor(Color.black);
    offGraphics.drawLine(distX,distY,distX,distY+290);
    offGraphics.fillOval(distX-3,distY+290,6,6);
    // placing relay Kc under switch 0 line
    if(zero&&on) offGraphics.drawImage(relayOnI,distX-11,distY+293,this);
    else offGraphics.drawImage(relayOffI,distX-11,distY+293,this);
    // placing horizontal/vertical lines at relais Kc
    distX=90;
    distY=375;
    offGraphics.drawLine(distX+3,distY,distX+544,distY);
    // vertical line from left/right rotation point to horizontal line 
    offGraphics.drawLine(distX+3,distY-55,distX+3,distY);
    offGraphics.drawLine(distX+544,distY-55,distX+544,distY);
    // Rotation point at left arrow
    offGraphics.setColor(Color.white);
    offGraphics.fillOval(distX+1,distY-55,6,6);
    if(zero&&on) offGraphics.setColor(Color.red);
    else offGraphics.setColor(Color.black);
    offGraphics.drawOval(distX+1,distY-55,5,5);
    // Rotation point at right arrow
    offGraphics.setColor(Color.white);
    offGraphics.fillOval(distX+541,distY-55,6,6);
    if(zero&&on) offGraphics.setColor(Color.red);
    else offGraphics.setColor(Color.black);
    offGraphics.drawOval(distX+541,distY-55,5,5);
    // drawing line under left vertical lines
    distX=205;
    distY=312;
    if(negative&&on) offGraphics.setColor(Color.red);
    else offGraphics.setColor(Color.black);
    offGraphics.drawLine(distX,distY,distX+140,distY);
    // drawing horizontal line on the left.
    distX=342;distY=100;
    int width=300;int height=307;
    // Ground
    offGraphics.setColor(Color.black);
    offGraphics.drawOval(distX-304,distY+220,5,5);
    int j=7;
    for(int i=0;i<8;i++) {
      // setting color
      if(buttons[j]&&on) offGraphics.setColor(Color.red);
      else offGraphics.setColor(Color.black);
      offGraphics.fillOval(distX,distY-3,6,6);
      offGraphics.drawLine(distX,distY,distX-width,distY);
      offGraphics.drawLine(distX-width,distY,distX-width,height);
      offGraphics.drawOval(distX-width-3,height,5,5);
      distX-=20;distY+=20;
      width-=35;j--;
      if(i==0) height=295;
      if(i==1) height=286;
      if(i==2) height=281;
      if(i==3) height=281;
      if(i==4) height=286;
      if(i==5) height=295;
      if(i==6) height=307;
    }
    // drawing horizontal line on the right.
    distX=382;distY=100;
    width=200;height=307;
    // Ground
    offGraphics.setColor(Color.black);
    offGraphics.drawOval(distX+196,distY+220,5,5);
    for(int i=0;i<8;i++) {
      if(buttons[i+9]&&on) offGraphics.setColor(Color.red);
      else offGraphics.setColor(Color.black);
      offGraphics.fillOval(distX,distY-3,6,6);
      offGraphics.drawLine(distX,distY,distX+width,distY);
      offGraphics.drawLine(distX+width,distY,distX+width,height);
      offGraphics.drawOval(distX+width-3,height,5,5);
      distX+=20;distY+=20;
      width-=5;
      if(i==0) height=295;
      if(i==1) height=286;
      if(i==2) height=281;
      if(i==3) height=281;
      if(i==4) height=286;
      if(i==5) height=295;
      if(i==6) height=307;
    }
    // drawing line under right vertical lines
    distX=386;
    distY=312;
    if(positive&&on) offGraphics.setColor(Color.red);
    else offGraphics.setColor(Color.black);
    offGraphics.drawLine(distX,distY,distX+140,distY);
    // putting relay Ka and Kb on sheet.
    distX=334;
    distY=315;
    if(negative&&on) offGraphics.drawImage(relayOnI,distX,distY,this);
    else offGraphics.drawImage(relayOffI,distX,distY,this);
    if(positive&&on) offGraphics.drawImage(rRelayOnI,distX+47,distY,this);
    else offGraphics.drawImage(rRelayOffI,distX+47,distY,this);
    // putting Labels
    offGraphics.setColor(Color.black);
    distX=375;
    distY=405;
    offGraphics.drawString("Kc",distX,distY);
    offGraphics.drawString("Ka",distX-65,distY-60);
    offGraphics.drawString("Kb",distX+28,distY-60);
    offGraphics.drawString("kd",distX-275,distY-70);
    offGraphics.drawString("kd",distX+266,distY-70);
  }
  /**
   * Method that realizes a rotating arrow.
   */
  private void rotate() {
    // left arrow
    if(arrowNr%9==0) 
      offGraphics.drawImage(arrowI[arrowNr%9],45,288,this);
    else /*(arrowNr!=0)*/ {
      if((arrowNr%9>0)&&(arrowNr%9<=8)) {
        int j=7;
        for(int i=1;i<9;i++) {
          if(arrowNr%9==i) {
            if(buttons[j]) {
              offGraphics.drawImage(arrowOnI[arrowNr%9],45,288,this);
              zero=true;
            }
            else offGraphics.drawImage(arrowI[arrowNr%9],45,288,this);
          }
          j--;
        }
      }
      else offGraphics.drawImage(arrowI[arrowNr%9],45,288,this);
    }
    // right arrow  
    if(buttons[(arrowNr%9)+8]) {
      offGraphics.drawImage(arrowOnI[arrowNr%9],585,288,this);
      zero=true;
    }
    else {
      offGraphics.drawImage(arrowI[arrowNr%9],585,288,this);
    }
  }
  /**
   * This method realizes an increasing progross bar.
   * @param g graphics variable in which the bar will be placed.
   * @param images number of images.
   */
  public void buildProgress(Graphics g,int images) {
    int factor=20;
    // scaling
    Dimension d=size();
    // Setting color
    g.setColor(Color.blue);
    int x1=d.width/2-(images*factor)/2;
    // drawing a rectangle round the bar
    g.drawRect(x1,d.height/2+20,factor*images,20);
    // realizing the increasing bar
    for(int i=0; i<=images; i++) {
      g.fillRect(x1,d.height/2+20,i*factor,20);
      try {
        tracker.waitForID(i);
      } catch (InterruptedException ie) {}
    }
    g.setColor(Color.black);
  }
  public void run() {
    try {
      // Start downloading the images. Wait until they're loaded
      // before requesting repaints.
      tracker.waitForAll();
    } catch (InterruptedException ie) {}
    while(Thread.currentThread()==thread) {
      // Working with reduced performance
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
      repaint();
      try {
        thread.sleep(500);
      }catch (InterruptedException ie) {}
      arrowNr=(on ? (arrowNr+1):0);
    }
  }
  public void paint(Graphics g) {
    update(g);
  }
  public void update(Graphics g) {
    // scaling
    Dimension d=size();
    // wait until all images are loaded
    if(!tracker.checkAll()) {
      g.setColor(Color.white);
      g.fillRect(0, 0, d.width, d.height);
      g.setColor(Color.black);
      g.drawString("Please wait, loading...",(d.width/2-80),d.height/2);
      buildProgress(g,32);
    }
    // now start drawing !!!
    else {
		  if ( (offGraphics==null) 
		  		|| (d.width!=offDimension.width) 
			  	|| (d.height!=offDimension.height) ) {
        offDimension=d;
        offImage=createImage(d.width, d.height);
        offGraphics=offImage.getGraphics();
      }
      // drawing white sheet
      offGraphics.setColor(Color.white);
      offGraphics.fillRect(0,0,d.width,d.height);
      offGraphics.setColor(Color.black);
      // drawing control buttons
      putControlsC();
      // drawing rotating arrow
      rotate();
      // drawing circuit
      putC();
      // painting Buffer on Applet
      g.drawImage(offImage,0,0,this);
    }
  }
}
