import java.applet.Applet;
import java.awt.*;
/**
 * Applet which simulates the Z3 (1941 Konrad Zuse) decimal to binary
 * conversion of a number.
 * @author Cneyt Gktekin
 * @version 1.0
 */
public class DecKey extends Applet implements Runnable {
  // needed for -double buffering-
  Dimension offDimension;
  Image offImage;
  Graphics offGraphics;
  /** Number of buttons. */
  int nr=9; 
  /** Some booleans to control the circuit. */
  /** Determs which decimal button is active. */
  boolean[] decB;
  /** ON/OFF button. */
  boolean on=false;
  /** Reset button. */
  boolean c=false;
  /** Temp indicates if the line is on power. */
  boolean lineActive=false;
  // Image handling
  /** Images for the control buttons.*/
  Image onAI;
  Image onDI;
  Image offI;
  Image resetONI;
  Image resetOFFI;
  /** Image for on/off decimal key. */
  Image[] decOnI;
  Image[] decOffI;
  /** Circuit Images. */
  /** Front line on which the switches will be placed. */
  Image switchLineI;
  /** Switches. */
  Image switchOffI;
  Image switchOnI;
  /** Bit Lines. */
  Image[] line3I;
  Image[] line2I;
  Image[] line1I;
  Image[] line0I;
  /** Media tracker to keep loading under control. */
  MediaTracker tracker;
  /** The main simulation thread. */
  private Thread thread=null;
  /** 
   * Method realizes the reset button (C).
   * It creates a new array with false values.
   */
  private void c() {
    decB=new boolean[nr];
  }
  /**
   * Loading Images and some other initialization.
   */
  public void init() {
    // Initializing decs
    c();
    // Loading images
    // first create a new MediaTracker object
    tracker=new MediaTracker(this);
    // control images
    onAI=getImage(getCodeBase(),"Images/Buttons/onA.gif");
    tracker.addImage(onAI,0);
    onDI=getImage(getCodeBase(),"Images/Buttons/onD.gif");
    tracker.addImage(onDI,0);
    offI=getImage(getCodeBase(),"Images/Buttons/off.gif");
    tracker.addImage(offI,0);
    resetOFFI=getImage(getCodeBase(),"Images/Buttons/resetOff.gif");
    tracker.addImage(resetOFFI,0);
    resetONI=getImage(getCodeBase(),"Images/Buttons/resetOn.gif");
    tracker.addImage(resetONI,0);
    // Images needed for all levels
    // off decimal keys
    decOffI=new Image[nr];
    for(int i=0; i<nr; i++) {
      decOffI[i]=getImage(getCodeBase(),"Images/Buttons/decOff"+(i+1)+".gif");
      tracker.addImage(decOffI[i],1);
    }
    // on decimal keys
    decOnI=new Image[nr];
    for(int i=0; i<nr; i++) {
      decOnI[i]=getImage(getCodeBase(),"Images/Buttons/decOn"+(i+1)+".gif");
      tracker.addImage(decOnI[i],2);
    }
    // front switch line
    switchLineI=getImage(getCodeBase(),"Images/switchLine.gif");
    tracker.addImage(switchLineI,3);
    // switch off
    switchOffI=getImage(getCodeBase(),"Images/switchOff.gif");
    tracker.addImage(switchOffI,4);
    // switch on
    switchOnI=getImage(getCodeBase(),"Images/switchOn.gif");
    tracker.addImage(switchOnI,5);
    // line3
    line3I=new Image[2];
    for(int i=0; i<2; i++) {
      line3I[i]=getImage(getCodeBase(),"Images/line3"+i+".gif");
      tracker.addImage(line3I[i],6);
    }
    // line3
    line2I=new Image[2];
    for(int i=0; i<2; i++) {
      line2I[i]=getImage(getCodeBase(),"Images/line2"+i+".gif");
      tracker.addImage(line2I[i],7);
    }
    // line3
    line1I=new Image[2];
    for(int i=0; i<2; i++) {
      line1I[i]=getImage(getCodeBase(),"Images/line1"+i+".gif");
      tracker.addImage(line1I[i],8);
    }
    // line0
    line0I=new Image[2];
    for(int i=0; i<2; i++) {
      line0I[i]=getImage(getCodeBase(),"Images/line0"+i+".gif");
      tracker.addImage(line0I[i],9);
    }
  }
  public void start() {
    if (thread==null) {
      thread=new Thread(this);
      thread.start();
    }
    else {
      thread=null;
      thread=new Thread(this);
      thread.start();
    }
  }
  public void stop() {
    thread=null;
  }
  /** 
   * Standard mouse event Method.
   * In this Method the clickable areas are defined.
   * @param e MouseEvent
   * @param x x coordinate 
   * @param y y coordinate
   */
  public boolean mouseDown(Event e,int x,int y) {
    // Managing behaviour on OFF button
    int x1Local=180;
    int y1Local=10;
    if((x>x1Local)&&(x<(x1Local+30))&&(y<y1Local+30)&&(y>y1Local)) {
      c();start();on=false;start();
    }
    // Managing behaviour on ON button
    x1Local+=30;
    if((x>x1Local)&&(x<(x1Local+30))&&(y<y1Local+30)&&(y>y1Local)) {
      on=true;start();
    }
    // Managing behaviour on reset button
    x1Local+=50;
    if((x>x1Local)&&(x<(x1Local+40))&&(y<y1Local+40)&&(y>y1Local)) {
      c=(c ? false:true);start();
    }
    // Managing behaviour on decimal buttons only if on !!!!
    if(on) {
    // button 9
    x1Local=72;
    y1Local=20;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[8]=true;start();
    }
    // button 8
    y1Local=73;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[7]=true;start();
    }
    // button 7
    y1Local=109;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[6]=true;start();
    }
    // button 6
    y1Local=177;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[5]=true;start();
    }
    // button 5
    y1Local=229;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[4]=true;start();
    }
    // button 4
    y1Local=284;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[3]=true;start();
    }
    // button 3
    y1Local=321;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[2]=true;start();
    }
    // button 2
    y1Local=372;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[1]=true;start();
    }
    // button 1
    y1Local=412;
    if((x>x1Local)&&(x<(x1Local+18))&&(y<y1Local+18)&&(y>y1Local)) {
      for(int i=0; i<9; i++) decB[i]=false;
      decB[0]=true;start();
    }
    }
    start();
    return true;
  }
  /** Method that puts the control buttons on the sheet. */
  private void putControlsC() {
    // putting ON/OFF button on sheet
    int distX=180;
    int distY=10;
    if(on) {
      offGraphics.drawImage(offI,distX,distY,this);
      offGraphics.drawImage(onAI,distX+30,distY,this);
    }
    else {
      offGraphics.drawImage(offI,distX,distY,this);
      offGraphics.drawImage(onDI,distX+30,distY,this);
    }
    // putting reset button on sheet
    distX+=80;
    offGraphics.drawImage(resetOFFI,distX,distY,this);
    if(c) {
      offGraphics.drawImage(resetOFFI,distX,distY,this);
      c();start();
      offGraphics.drawImage(resetONI,distX,distY,this);
      c=false;start();
      on=false;start();
    }
  }  
  /** Method that puts the dec buttons on the sheet. */
  private void putDecButtonsC() {
    int distX=72;
    int distY=20;
    if(decB[8]&&on) offGraphics.drawImage(decOnI[8],distX,distY,this);
    else offGraphics.drawImage(decOffI[8],distX,distY,this);
    distY+=53;
    if (decB[7]&&on) offGraphics.drawImage(decOnI[7],distX,distY,this);
    else offGraphics.drawImage(decOffI[7],distX,distY,this);
    distY+=36;
    if (decB[6]&&on) offGraphics.drawImage(decOnI[6],distX,distY,this);
    else offGraphics.drawImage(decOffI[6],distX,distY,this);
    distY+=68;
    if(decB[5]&&on) offGraphics.drawImage(decOnI[5],distX,distY,this);
    else offGraphics.drawImage(decOffI[5],distX,distY,this);
    distY+=52;
    if(decB[4]&&on) offGraphics.drawImage(decOnI[4],distX,distY,this);
    else offGraphics.drawImage(decOffI[4],distX,distY,this);
    distY+=55;
    if(decB[3]&&on) offGraphics.drawImage(decOnI[3],distX,distY,this);
    else offGraphics.drawImage(decOffI[3],distX,distY,this);
    distY+=37;
    if(decB[2]&&on) offGraphics.drawImage(decOnI[2],distX,distY,this);
    else offGraphics.drawImage(decOffI[2],distX,distY,this);
    distY+=51;
    if(decB[1]&&on) offGraphics.drawImage(decOnI[1],distX,distY,this);
    else offGraphics.drawImage(decOffI[1],distX,distY,this);
    distY+=40;
    if(decB[0]&&on) offGraphics.drawImage(decOnI[0],distX,distY,this);
    else offGraphics.drawImage(decOffI[0],distX,distY,this);
  }
  /** Method that puts the first level switches on the sheet. */
  private void putC() {
    // drawing front line on sheet
    int distX=20;
    int distY=10;
    offGraphics.drawImage(switchLineI,distX,distY,this);
    // putting switches on sheet
    distX=66;
    distY=41;
    if(on&&decB[8]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=56;
    if(on&&decB[8]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=94;
    if(on&&decB[7]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=132;
    if(on&&decB[6]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=147;
    if(on&&decB[6]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=162;
    if(on&&decB[6]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=200;
    if(on&&decB[5]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=215;
    if(on&&decB[5]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=253;
    if(on&&decB[4]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=268;
    if(on&&decB[4]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=306;
    if(on&&decB[3]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=343;
    if(on&&decB[2]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=358;
    if(on&&decB[2]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=396;
    if(on&&decB[1]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    distY=434;
    if(on&&decB[0]) offGraphics.drawImage(switchOnI,distX,distY,this);
    else offGraphics.drawImage(switchOffI,distX,distY,this);
    // putting line3 on sheet (the most left)
    distX=86;
    distY=45;
    if(on&&(decB[8]||decB[7])) {
      offGraphics.drawImage(line3I[1],distX,distY,this);
      offGraphics.drawString("1",106,485);
    }
    else {
      offGraphics.drawImage(line3I[0],distX,distY,this);
      offGraphics.drawString("0",106,485);
    }
    // putting line2 on sheet
    distX=86;
    distY=136;
    if(on&&(decB[6]||decB[5]||decB[4]||decB[3])) {
      offGraphics.drawImage(line2I[1],distX,distY,this);
      offGraphics.drawString("1",132,485);
    }
    else {
      offGraphics.drawImage(line2I[0],distX,distY,this);
      offGraphics.drawString("0",132,485);
    }
    // putting line1 on sheet
    distX=86;
    distY=151;
    if(on&&(decB[6]||decB[5]||decB[2]||decB[1])) {
      offGraphics.drawImage(line1I[1],distX,distY,this);
      offGraphics.drawString("1",159,485);
    }
    else {
      offGraphics.drawImage(line1I[0],distX,distY,this);
      offGraphics.drawString("0",159,485);
    }
    // putting line1 on sheet
    distX=86;
    distY=60;
    if(on&&(decB[8]||decB[6]||decB[4]||decB[2]||decB[0])) {
      offGraphics.drawImage(line0I[1],distX,distY,this);
      offGraphics.drawString("1",185,485);
    }
    else {
      offGraphics.drawImage(line0I[0],distX,distY,this);
      offGraphics.drawString("0",185,485);
    }
  }
  /**
   * This method realizes an increasing progross bar.
   * @param g graphics variable in which the bar will be placed.
   * @param images number of images.
   */
  public void buildProgress(Graphics g,int images) {
    int factor=20;
    // scaling
    Dimension d=size();
    // Setting color
    g.setColor(Color.blue);
    int x1=d.width/2-(images*factor)/2;
    // drawing a rectangle round the bar
    g.drawRect(x1,d.height/2+20,factor*images,20);
    // realizing the increasing bar
    for(int i=0; i<=images; i++) {
      g.fillRect(x1,d.height/2+20,i*factor,20);
      try {
        tracker.waitForID(i);
      } catch (InterruptedException ie) {}
    }
    g.setColor(Color.black);
  }
  public void run() {
    try {
      // Start downloading the images. Wait until they're loaded
      // before requesting repaints.
      tracker.waitForAll();
    } catch (InterruptedException ie) {}
    while(Thread.currentThread()==thread) {
      // Working with reduced performance
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
      repaint();
      try {
        thread.sleep(500);
      }catch (InterruptedException ie) {}
    }
  }
  public void paint(Graphics g) {
    update(g);
  }
  public void update(Graphics g) {
    // scaling
    Dimension d=size();
    // wait until all images are loaded
    if(!tracker.checkAll()) {
      g.setColor(Color.white);
      g.fillRect(0, 0, d.width, d.height);
      g.setColor(Color.black);
      g.drawString("Please wait, loading...",(d.width/2-80),d.height/2);
      buildProgress(g,10);
    }
    // now start drawing !!!
    else {
		  if ( (offGraphics==null) 
		  		|| (d.width!=offDimension.width) 
			  	|| (d.height!=offDimension.height) ) {
        offDimension=d;
        offImage=createImage(d.width, d.height);
        offGraphics=offImage.getGraphics();
      }
      // drawing white sheet
      offGraphics.setColor(Color.white);
      offGraphics.fillRect(0,0,d.width,d.height);
      offGraphics.setColor(Color.black);
      // drawing control buttons
      putControlsC();
      // placing bit buttons
      putDecButtonsC();
      // placing circuit on sheet
      putC();
      // painting Buffer on Applet
      g.drawImage(offImage,0,0,this);
    }
  }
}
